@extends("admin.template.layout")
<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/css/select2.min.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js"></script>
@section('header')
    <style>
        .form-control-plaintext {
            padding-left: 7px;
            border: 1px solid #990253;
            border-radius: 10px;
            color: #212529;
            text-align: left;
            margin-bottom: 15px;
        }

        .form-label {
            margin-bottom: 5px;
        }

        .img-view{
            cursor: zoom-in;
        }
        .btn-primary {
  display: none;
}
    </style>
@endsection
@section('content')
    <div class="container-xxl flex-grow-1 container-p-y">

        <!-- Ajax Sourced Server-side -->
        <div class="card">
            <div class="card-header d-flex justify-content-between align-items-center">
                <h5 class="mb-0">{{$mode ?? $page_heading}}</h5>
            </div>
            <div class="card-body py-0">
                <div class="row">
                    {{--
                    <div class="col-md-2 col-sm-4 primary-btn    py-4 rounded">
                        <div class="card">
                            <div class="card-body">
                                <div class="text-center">
                                    <img src="{{get_uploaded_image_url($user->user_image, 'user_image_upload_dir')}}"
                                         class="img-fluid rounded-circle"
                                         alt="Responsive image">
                                </div>
                            </div>
                        </div>
                    </div>
                    --}}
                    
                        <div class="col-md-12 col-sm-12 py-4">
                            <form id="admin_form" action = "{{ route('drivers.update',['id' => $user->id]) }}" method = "POST" enctype="multipart/form-data">
                                @csrf
                                <input type = "hidden" name = "driver_detail_id" value = "{{ $user->driver_detail->id }}">
                            <div class="row">
                                @php
                                    $is_company = $user->driver_detail->is_company == 'no'?0:1;
                                @endphp
                                <div class="col-md-6" id = "driver-type-div" style="display:none;">
                                    <label class="form-label">Driver Type</label>
                                    <select class="form-control-plaintext" name = "driver_type" id = "driver_type" >
                                        <option>Select Driver Type</option>
                                        @foreach($get_driver_types as $driver_type)
                                        <option value = "{{$driver_type->id}}" {{$is_company == $driver_type->id?'selected':''}} >{{$driver_type->type}}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="col-md-6" id = "company-div" style = "display: {{ $user->driver_detail->is_company == 'no'?'none':'' }};">
                                    <label class="form-label">Comapany</label>
                                    <select class="form-control-plaintext" name = "company" style = "">
                                        @foreach($companies as $company)
                                        <option value = "{{$company->id}}"  {{ $user->driver_detail->company_id == $company->id ?'selected':'' }}>{{$company->name}}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="col-md-6" style="display:none;">
                                    <label class="form-label">Truck Type</label>
                                    <select class="form-control-plaintext" name = "truck_type" style = "">
                                        @foreach($trucks as $truck)
                                        <option value = "{{$truck->id}}" >{{$truck->truck_type." -- ".$truck->dimensions}}</option>
                                        @endforeach
                                    </select>
                                </div>
                               
                                <div class="col-md-6">
                                    <label class="form-label">First Name</label>
                                    <input type = "text" class="form-control-plaintext" name = "first_name" value ="{{$user->first_name }}" data-jqv-required="true">
                                </div>
                                <div class="col-md-6">
                                    <label class="form-label">Last Name</label>
                                    <input type = "text" class="form-control-plaintext" name = "last_name" value ="{{$user->last_name }}" data-jqv-required="true">
                                </div>
                                <div class="col-md-6">
                                    <label class="form-label">Email</label>
                                    <input type = "email" class="form-control-plaintext" name = "email" value = "{{$user->email}}" data-jqv-required="true">
                                </div>
                                <div class="col-md-6">
                                    <label class="form-label">Password</label>
                                    <input type = "password" class="form-control-plaintext" name = "password" value = "" id = "password" >
                                </div>
                                <div class="col-md-6">
                                    <label class="form-label">Confirm Password</label>
                                    <input type = "password" class="form-control-plaintext" name = "confirm_password" value = "" id = "confirm_password" >
                                    <span id='password-message'></span>
                                </div>
                                <div class="col-md-2">
                                    <label class="form-label">Phone</label>
                                    <select class="form-control-plaintext" name = "dial_code" data-jqv-required="true">
                                        <option>Dial Code</option>
                                        @foreach(dial_codes() as $key => $country)
                                        <option value = "{{$key}}" {{ $key == $user->dial_code?'selected':'' }}>{{$key}}</option>
                                        @endforeach
                                    </select>
                                </div>
                                <div class="col-md-4">
                                    <label class="form-label">Number</label>
                                    <input type = "text" class="form-control-plaintext" name = "phone" value = "{{$user->phone}}" data-jqv-required="true">
                                </div>

                                <div class="col-md-6">
                                    <label class="form-label">Account Status</label>
                                    <select class="form-control-plaintext" name = "status">
                                        <option value = "inactive" {{ $user->status == 'inactive'?'selected':'' }}>Inactive</option>
                                        <option value = "active" {{ $user->status == 'active'?'selected':'' }}>Active</option>
                                    </select>
                            </div>
                            <div class="col-md-6">
                                <label class="form-label">Vehicle Types</label>
                                @php
                                $vehicle_type=[];
                                if(!empty($user->vehicle_type)){
                                    $vehicle_type= explode(',',$user->vehicle_type);
                                }
                                
                                 
                                @endphp
                                <select id="VehicleTypes" multiple="true" class="form-control-plaintext" name = "vehicle_type[]">
                                    <option value = "Car"  {{ in_array('Car',$vehicle_type )?'selected':'' }}>Car</option>
                                    <option value = "Boat"  {{in_array('Boat',$vehicle_type )?'selected':'' }}>Boat</option>
                                    <option value = "MotorCycle" {{ in_array('MotorCycle',$vehicle_type )?'selected':'' }}>MotorCycle</option>
                                </select>
                            </div>
                            </div>
                                <!-- Driving Documents -->
                        <div class = "row">
                                    <div class = "col-md-12">
                                        <hr />
                                    </div>

                                    <div class="col-md-6">
                                        @if(!empty($user->driver_detail->mulkia))
                                            <img src = "{{ $user->driver_detail->mulkia }}" width = 100 data-toggle="modal" data-target="#exampleModalCenter" class = "img-view img-thumbnail">
                                        @endif
                                        <label class="form-label">Upload Mulkiya</label>
                                        <input type = "file" name = "mulkiya" class = "form-control-plaintext" value = "{{ $user->driver_detail->mulkia ?? '' }}" >
                                    </div>
                                    <div class="col-md-6">
                                        <label class="form-label">Mulkiya Number</label>
                                        <input type = "text" class="form-control-plaintext" name = "mulkiya_number" value = "{{ $user->driver_detail->mulkia_number ?? '' }}">
                                    </div>   

                                    <div class="col-md-6">
                                        @if(!empty($user->driver_detail->emirates_id_or_passport))
                                            <img src = "{{ $user->driver_detail->emirates_id_or_passport }}" width = 100 data-toggle="modal" data-target="#exampleModalCenter" class = "img-view img-thumbnail">
                                        @endif
                                        <label class="form-label">Upload Emirate ID or Passport</label>
                                        <input type = "file" name = "emirates_id_or_passport" class = "form-control-plaintext" >
                                    </div>

                                    <div class="col-md-6">
                                        <label class="form-label">Drving License Issued By</label>
                                        <select class="form-control-plaintext" name = "driving_license_issued_by" data-jqv-required="true">
                                            @foreach(get_countries() as $key => $country)
                                            <option value = "{{$country}}" {{ $user->driver_detail->driving_license_issued_by == $country?'selected':'' }}>{{$country}}</option>
                                            @endforeach
                                        </select>    
                                    </div>

                                    <div class="col-md-6">
                                        @if(!empty($user->driver_detail->driving_license))
                                            <img src = "{{ $user->driver_detail->driving_license }}" width = 100 data-toggle="modal" data-target="#exampleModalCenter" class = "img-view img-thumbnail">
                                        @endif
                                        <label class="form-label">Upload Driving License</label>
                                        <input type = "file" name = "driving_license" class = "form-control-plaintext" >
                                    </div>

                                    <div class="col-md-3">
                                        <label class="form-label">Driving License Number</label>
                                        <input type = "text" class="form-control-plaintext" name = "driving_license_number" value = "{{ $user->driver_detail->driving_license_number ?? '' }}" data-jqv-required="true" >
                                    </div>

                                    <div class="col-md-3">
                                        <label class="form-label">Driving License Expiry</label>
                                        <input type = "date" class="form-control-plaintext" name = "driving_license_expiry" value = "{{ $user->driver_detail->driving_license_expiry ?? '' }}" data-jqv-required="true">
                                    </div>

                                   
                                
                                </div>    

                                <!-- Address Section -->
                                <div class = "row">
                                    <div class = "col-md-12">
                                            <hr />
                                    </div>
                                    <div class="col-md-6">
                                        <label class="form-label">Country</label>
                                        <select class="form-control-plaintext" name = "country" data-jqv-required="true">
                                            @foreach(get_countries() as $key => $country)
                                            <option value = "{{$country}}" {{ $user->country == $country ?'selected':'' }}>{{$country}}</option>
                                            @endforeach
                                        </select>    
                                    </div>

                                    <div class="col-md-6">
                                        <label class="form-label">City</label>
                                        <input type = "text" name = "city" class="form-control" placeholder = "" value = "{{ $user->city ?? ''}}">
                                    </div>

                                    <div class="col-md-6">
                                        <label class="form-label">Zip Code</label>
                                        <input type = "number" name = "zip_code" class="form-control" placeholder = "" value = "{{ $user->zip_code ?? ''}}">
                                    </div>

                                    
                                </div>
                                

                                <div class = "row">
                                <div class="col-sm-3">
                                    <input class = "btn btn-info float-right" type = "submit" name = "submit" value = "Save Information">
                                </div>
                            </div>
                        </form>
                        </div>
                    
                </div>
            </div>
        </div>
    </div>
    

<!-- Modal -->
<div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered" role="document">
    <div class="modal-content">
      
      <img src = "" width = "100%" class = "img img-thumbnail" id = "display-image">                  

    </div>
  </div>
</div>


@stop
@section('script')
    <script>
        jQuery(document).ready(function () {

            $('#VehicleTypes').select2();

            $(document).on('click','.img-view',function(){
                let src = $(this).attr('src');
                $('#display-image').attr('src',src);
            })
            $(document).on('change','#driver_type',function(){
                if($(this).val() == 1){
                    $('#company-div').show();
                }else{
                    $('#company-div').hide();
                }
            })
            App.initTreeView();

                $('.all-select').click(function(){
        $(this).siblings('.crud-items').prop('checked', this.checked);
    });
    $('.crud-items').click(function(){
        $(this).siblings('.all-select').prop('checked', false);
    });
    $('.all-p').click(function(){
        $(this).siblings('.reader').prop('checked', true);
    });
    App.initFormView();
    let form_in_progress=0;

    $('body').off('submit', '#admin_form');
    $('body').on('submit', '#admin_form', function(e) {
        e.preventDefault();
        var validation = $.Deferred();
        var $form = $(this);
        var formData = new FormData(this);

        var vehicleType = $('#vehicle_type').val();  // Get the selected values
if (vehicleType) {
    vehicleType.forEach(function(value) {
        formData.append('vehicle_type[]', value);
    });
}

        $form.validate({
            rules: {
                name:{
                    required:true
                },
                email:{
                    required:true,
                    email:true
                },
                confirm_password:{

                    equalTo:"#password"
                },
                dial_code:{
                    required:true
                },
                phone:{
                    required:true
                },
                mulkiya_number:{
                  required:true  
                },
                driving_license_issued_by:{
                  required:true  
                },
                driving_license_number:{
                  required:true  
                },
                driving_license_expiry:{
                  required:true  
                },
                vehicle_plate_number:{
                  required:true  
                },
                vehicle_plate_place:{
                  required:true  
                },
                country:{
                  required:true  
                },
                zip_code:{
                  required:true  
                },
                city:{
                  required:true  
                },
                driver_type:{
                  required:true  
                }
            },
            errorElement: 'div',
            errorPlacement: function(error, element) {
                element.addClass('is-invalid');
                error.addClass('error');
                error.insertAfter(element);
            }
        });

        // Bind extra rules. This must be called after .validate()
        App.setJQueryValidationRules('#admin_form');

        if ( $form.valid() ) {
            validation.resolve();
        } else {
            var error = $form.find('.is-invalid').eq(0);
            $('html, body').animate({
                scrollTop: (error.offset().top - 100),
            }, 500);
            validation.reject();
        }

        validation.done(function() {
            $form.find('.is-invalid').removeClass('is-invalid');
            $form.find('div.error').remove();


            App.button_loading(true);


            form_in_progress = 1;
            $.ajax({
                type: "POST",
                enctype: 'multipart/form-data',
                url: $form.attr('action'),
                data: formData,
                processData: false,
                contentType: false,
                cache: false,
                timeout: 600000,
                dataType:'html',
                success: function (res) {
                    res = JSON.parse(res);
                    console.log(res['status']);
                    form_in_progress = 0;
                    App.button_loading(false);
                    if ( res['status'] == 0 ) {
                        if ( typeof res['errors'] !== 'undefined' ) {
                            var error_def = $.Deferred();
                            var error_index = 0;
                            jQuery.each(res['errors'], function (e_field, e_message) {
                                if ( e_message != '' ) {
                                    $('[name="'+ e_field +'"]').eq(0).addClass('is-invalid');
                                    $('<div class="error">'+ e_message +'</div>').insertAfter($('[name="'+ e_field +'"]').eq(0));
                                    if ( error_index == 0 ) {
                                        error_def.resolve();
                                    }
                                    error_index++;
                                }
                            });
                            error_def.done(function() {
                                var error = $form.find('.is-invalid').eq(0);
                                                $('html, body').animate({
                                                    scrollTop: (error.offset().top - 100),
                                                }, 500);
                                            });
                        } else {
                            var m = res['message']||'Unable to save variation. Please try again later.';
                            App.alert(m, 'Oops!','error');
                        }
                    } else {
                        App.alert(res['message']||'Record saved successfully', 'Success!','success');
                        setTimeout(function(){
                            window.location.href = res['oData']['redirect'];
                        },2500);

                    }

                },
                error: function (e) {
                    form_in_progress = 0;
                    App.button_loading(false);
                    console.log(e);
                    App.alert( "Network error please try again", 'Oops!','error');
                }
            });
        });
    });
        })
    </script>
@stop
